package dev.pfaff.altargui.debug.events;

import dev.pfaff.log4truth.format.AppendTo;
import dev.pfaff.log4truth.format.Appender;

import static java.util.FormatProcessor.FMT;

public sealed interface MarkNeedsLayoutEvent extends WidgetStateEvent {
	long key();

	@Override
	default void appendTo(Appender appender) {
		String litA = "MarkNeeds";
		String litB = "Layout[key=";
		String litC = "]";
		String className = getClass().getSimpleName();
		String keyString = FMT."%016x\{key()}";
		appender.reserve(litA.length() + className.length() + litB.length() + keyString.length() + litC.length());
		appender.append(litA);
		appender.append(className);
		appender.append(litB);
		appender.append(keyString);
		appender.append(litC);
	}

	record Stencil(long key) implements MarkNeedsLayoutEvent {
		@Override
		public String toString() {
			return AppendTo.toString(this);
		}
	}

	record Trace(long key) implements MarkNeedsLayoutEvent {
		@Override
		public String toString() {
			return AppendTo.toString(this);
		}
	}

	record Scissor(long key) implements MarkNeedsLayoutEvent {
		@Override
		public String toString() {
			return AppendTo.toString(this);
		}
	}
}
