package dev.pfaff.altargui.function;

import java.util.concurrent.Callable;

@FunctionalInterface
public interface FallibleRunnable extends Callable<Void> {
	void run() throws Exception;

	@Override
	default Void call() throws Exception {
		run();
		return null;
	}

	static FallibleRunnable asFallible(Runnable runnable) {
		return runnable::run;
	}
}
